DECLARE SUB CheckFiles (invoer$, uitvoer$)
DECLARE FUNCTION FileExists% (invoer$)

DECLARE SUB EGA2BMP (invoer$, uitvoer$, deelegagrootte%)
DECLARE SUB Decrypt (invoer$, N%, deelegagrootte%)
DECLARE SUB ViewEGA ()
DECLARE SUB DumpBMP (uitvoer$, aantal%, N%)
DECLARE SUB WriteBMPHeader (uitvoer$, heihoogte%, breedte%)

DECLARE SUB BMP2EGA (invoer$, uitvoer$, aantal%, aantalperaantal%, breedte%, hoogte%, deelegagrootte%)
DECLARE SUB ViewBMP (invoer$, N%, aantal%)
DECLARE SUB ReadEGA (aantalperaantal%, breedte%, hoogte%)
DECLARE SUB Encrypt (deelegagrootte%)
DECLARE SUB DumpEGA (uitvoer$, N%, deelegagrootte%)

DIM SHARED deelega AS STRING

DIM SHARED xorGetal(0 TO 27) AS INTEGER
FOR i% = 0 TO 27
  READ j%
  xorGetal(i%) = j%
NEXT i%

DIM SHARED palet AS STRING * 64
FOR i% = 1 TO 64
  READ j%
  MID$(palet, i%, 1) = CHR$(j%)
NEXT i%

'xorGetallen
DATA 67, 111, 112, 121, 114, 105, 103, 104, 116,  32,  49, 57,  57, 49
DATA 32,  80, 101, 100, 101, 114,  32,  74, 117, 110, 103, 99, 107,  0

'palet
DATA  0,  0,   0, 0, 168,  0,   0, 0,  0, 168,   0, 0, 168, 168,   0, 0
DATA  0,  0, 168, 0, 168,  0, 168, 0,  0,  84, 168, 0, 168, 168, 168, 0
DATA 84, 84,  84, 0, 252, 84,  84, 0, 84, 252,  84, 0, 252, 252,  84, 0
DATA 84, 84, 252, 0, 252, 84, 252, 0, 84, 252, 252, 0, 252, 252, 252, 0

TYPE BMPHeaderType
  id AS STRING * 2      'Should be "BM"
  size AS LONG          'Size of the file
  reserved AS LONG      '
  offset AS LONG        'Position of start of pixel data
  sizeheader AS LONG    '
  wid AS LONG           'Image width
  hei AS LONG           'Image height
  planes AS INTEGER     '
  bpp AS INTEGER        'Should read 4 for a 16 colour image
  compression AS LONG   '
  sizeimage AS LONG     'Width*Height
  xres AS LONG          '
  yres AS LONG          '
  colorused AS LONG     '
  colorimportant AS LONG'
  pal AS STRING * 64    'Stored as <Blue, Green, Red, 0>
END TYPE

PRINT "Sammod by Frenkel Smeijers, version 1.0, 1 jan 2005"
PRINT "frenkel_smeijers@hotmail.com"
PRINT "http://www.sfprod.cjb.net"
PRINT
INPUT "Episode (1, 2 or 3)"; episode%
IF episode% < 1 OR episode% > 3 THEN END

episode$ = LTRIM$(STR$(episode%))
bmp$ = "Sam" + episode$ + "tile.bmp"
samgfx$ = "Sam" + episode$ + ".gfx"

PRINT "1) Export tiles     to BMP,"
PRINT "2) Export statusbar to BMP,"
PRINT "3) Import tiles     to SAM,"
INPUT "4) Import statusbar to SAM"; eoi%

IF eoi% = 1 THEN
  EGA2BMP "Sam" + episode$ + "01.gfx", "Sam" + episode$ + "tile.bmp", 8064
ELSEIF eoi% = 2 THEN
  EGA2BMP "Sam" + episode$ + "02.gfx", "Sam" + episode$ + "bar.bmp", 2048
ELSEIF eoi% = 3 THEN
  BMP2EGA "Sam" + episode$ + "tile.bmp", "Sam" + episode$ + "01.gfx", 16, 50, 2, 16, 8064
ELSEIF eoi% = 4 THEN
  BMP2EGA "Sam" + episode$ + "bar.bmp", "Sam" + episode$ + "02.gfx", 3, 50, 1, 8, 2048
ELSE
  END
END IF

SCREEN 0
PRINT "Sammod by Frenkel Smeijers, version 1.0, 1 jan 2005"
PRINT "frenkel_smeijers@hotmail.com"
PRINT "http://www.sfprod.cjb.net"
END

SUB BMP2EGA (invoer$, uitvoer$, aantal%, aantalperaantal%, breedte%, hoogte%, deelegagrootte%) STATIC
CheckFiles invoer$, uitvoer$

deelega = SPACE$(deelegagrootte%)
SCREEN 9
FOR m% = 1 TO aantal%
  ViewBMP invoer$, m%, aantal%
  ReadEGA aantalperaantal%, breedte%, hoogte%
  Encrypt deelegagrootte%
  DumpEGA uitvoer$, m% - 1, deelegagrootte%
NEXT m%
END SUB

SUB CheckFiles (invoer$, uitvoer$) STATIC
IF FileExists%(invoer$) = 0 THEN
  PRINT invoer$ + " does not exist."
  KILL invoer$
  END
END IF

IF FileExists%(uitvoer$) THEN
  PRINT uitvoer$ + " already exists. Overwrite file (Y/N)?"
  toets$ = ""
  DO
    toets$ = UCASE$(INKEY$)
  LOOP WHILE toets$ = ""
  IF toets$ <> "Y" THEN END ELSE KILL uitvoer$
END IF
END SUB

SUB Decrypt (invoer$, N%, deelegagrootte%) STATIC
OPEN invoer$ FOR BINARY ACCESS READ AS #1
GET #1, N% * CLNG(deelegagrootte%) + 1, deelega

FOR m% = 1 TO deelegagrootte%
  byte% = ASC(MID$(deelega, m%, 1))
 
  j% = 0
  FOR i% = 0 TO 7
    IF (2 ^ i%) AND byte% THEN j% = j% OR (2 ^ (i% XOR 7))
  NEXT i%

  MID$(deelega, m%, 1) = CHR$(j% XOR xorGetal((m% - 1) MOD 28))
NEXT m%
CLOSE #1
END SUB

SUB DumpBMP (uitvoer$, aantal%, N%) STATIC
  j% = 0
  apa% = ASC(MID$(deelega, 1, 1)) - 1
  hor% = ASC(MID$(deelega, 2, 1)) * 64
  ver% = ((apa% \ 4) + (apa% AND 3)) * ASC(MID$(deelega, 3, 1))
  deelbmpgrootte% = hor% * ver% \ 2
  deelbmp$ = SPACE$(deelbmpgrootte%)
  FOR Y% = ver% - 1 TO 0 STEP -1
    FOR x% = 0 TO hor% - 1 STEP 2
      j% = j% + 1
      MID$(deelbmp$, j%, 1) = CHR$((POINT(x%, Y%) * 16) + POINT(x% + 1, Y%))
    NEXT x%
  NEXT Y%
  OPEN uitvoer$ FOR BINARY ACCESS WRITE AS #1
  PUT #1, (deelbmpgrootte% * CLNG(aantal%) + 118) - CLNG(deelbmpgrootte%) * N% + 1, deelbmp$
  CLOSE #1
END SUB

SUB DumpEGA (uitvoer$, N%, deelegagrootte%) STATIC
OPEN uitvoer$ FOR BINARY ACCESS WRITE AS #1
PUT #1, N% * CLNG(deelegagrootte%) + 1, deelega
CLOSE #1
END SUB

SUB EGA2BMP (invoer$, uitvoer$, deelegagrootte%) STATIC
CheckFiles invoer$, uitvoer$
deelega = SPACE$(deelegagrootte%)

OPEN invoer$ FOR BINARY ACCESS READ AS #1
aantal% = LOF(1) / deelegagrootte%
CLOSE #1
SCREEN 9
heihoogte% = 0
FOR m% = 1 TO aantal%
  Decrypt invoer$, m% - 1, deelegagrootte%
  ViewEGA
  DumpBMP uitvoer$, aantal%, m%
  apa% = ASC(MID$(deelega, 1, 1))
  heihoogte% = heihoogte% + (((apa% - 1) \ 4) + ((apa% - 1) AND 3)) * ASC(MID$(deelega, 3, 1))
NEXT m%
WriteBMPHeader uitvoer$, heihoogte%, ASC(MID$(deelega, 2, 1))
END SUB

SUB Encrypt (deelegagrootte%) STATIC
FOR j% = 1 TO deelegagrootte%
  b1% = ASC(MID$(deelega, j%, 1)) XOR xorGetal((j% - 1) MOD 28)
  b2% = 0
  FOR i% = 0 TO 7
    IF (2 ^ i%) AND b1% THEN b2% = b2% OR (2 ^ (i% XOR 7))
  NEXT i%

  MID$(deelega, j%, 1) = CHR$(b2%)
NEXT j%
END SUB

FUNCTION FileExists% (invoer$) STATIC
OPEN invoer$ FOR BINARY ACCESS READ AS #1
IF LOF(1) THEN FileExists% = -1 'ELSE FileExists% = 0
CLOSE #1
END FUNCTION

SUB ReadEGA (aantalperaantal%, breedte%, hoogte%) STATIC
DIM bp(0 TO 3) AS INTEGER 'bitplane

MID$(deelega, 1, 1) = CHR$(aantalperaantal%)
MID$(deelega, 2, 1) = CHR$(breedte%)
MID$(deelega, 3, 1) = CHR$(hoogte%)

j% = 3
DEF SEG = &HA000
FOR m% = 0 TO aantalperaantal% - 1
  coor% = (m% \ 4) * 80 * hoogte% + (m% AND 3) * breedte%
  FOR Y% = 0 TO hoogte% * 80 - 1 STEP 80
    FOR x% = 0 TO breedte% - 1
      memoffset% = Y% + x% + coor%
      j% = j% + 1
      FOR i% = 0 TO 3
        j% = j% + 1
        OUT &H3CE, 4
        OUT &H3CF, i%
        MID$(deelega, j%, 1) = CHR$(PEEK(memoffset%))
        bp(i%) = (NOT PEEK(memoffset% + 4 * breedte%)) AND 255
      NEXT i%
      MID$(deelega, j% - 4, 1) = CHR$(bp(0) OR bp(1) OR bp(2) OR bp(3))
    NEXT x%
  NEXT Y%
NEXT m%
DEF SEG
END SUB

SUB ViewBMP (invoer$, N%, aantal%) STATIC
DIM BH AS BMPHeaderType 'BMPHeader
OPEN invoer$ FOR BINARY ACCESS READ AS #1
GET #1, 1, BH
deelbmpgrootte% = BH.sizeimage \ aantal%
deelbmp$ = SPACE$(deelbmpgrootte%)
GET #1, BH.size - CLNG(deelbmpgrootte%) * N% + 1, deelbmp$
j% = 0
FOR Y% = (deelbmpgrootte% * 2 \ BH.wid) - 1 TO 0 STEP -1
  FOR x% = 0 TO BH.wid - 1 STEP 2
    j% = j% + 1
    kleur% = ASC(MID$(deelbmp$, j%, 1))
    PSET (x%, Y%), kleur% \ 16
    PSET (x% + 1, Y%), kleur% AND 15
  NEXT x%
NEXT Y%
CLOSE #1
END SUB

SUB ViewEGA STATIC
aantalperaantal% = ASC(MID$(deelega, 1, 1))
breedte% = ASC(MID$(deelega, 2, 1))
hoogte% = ASC(MID$(deelega, 3, 1))
DEF SEG = &HA000
FOR i% = -1 TO 3
  OUT &H3C4, 2
  IF i% = -1 THEN OUT &H3C5, 15 ELSE OUT &H3C5, 2 ^ i%
  j% = i%
  FOR m% = 0 TO aantalperaantal% - 1
    coor% = (m% \ 4) * 80 * hoogte% + (m% AND 3) * breedte%
    FOR Y% = 0 TO hoogte% * 80 - 1 STEP 80
      FOR x% = 0 TO breedte% - 1
        memoffset% = Y% + x% + coor%
        j% = j% + 5
        byte% = ASC(MID$(deelega, j%, 1))
        IF i% = -1 THEN POKE memoffset% + 4 * breedte%, NOT byte% ELSE POKE memoffset%, byte%
      NEXT x%
    NEXT Y%
  NEXT m%
NEXT i%
DEF SEG
END SUB

SUB WriteBMPHeader (uitvoer$, heihoogte%, breedte%) STATIC
DIM BH AS BMPHeaderType 'BMPHeader
BH.id = "BM"
BH.reserved = 0
BH.offset = 118
BH.sizeheader = 40
BH.wid = 4 * breedte% * 8 * 2
BH.hei = heihoogte%
BH.planes = 1
BH.bpp = 4
BH.compression = 0
BH.sizeimage = BH.wid * BH.hei \ 2
BH.size = BH.sizeimage + BH.offset
BH.xres = 0
BH.yres = 0
BH.colorused = 16
BH.colorimportant = 16
BH.pal = palet

OPEN uitvoer$ FOR BINARY ACCESS WRITE AS #1
PUT #1, 1, BH
CLOSE #1
END SUB

